﻿using System.Collections.Generic;
using UnityEngine;
using System.Linq;
using System;

namespace Oxide.Plugins
{
    [Info("HandsSmelt", "Kaidoz | vk.com/kaidoz", "1.1.0")]
    [Description("Meltdown plugin instantly")]

    class HandsSmelt : HurtworldPlugin
    {
        private struct C
        {
            public static List<object> listw = new List<object>
            {
                999
            };
        }

        void Loaded()
        {
            permission.RegisterPermission("handssmelt.use", this);
            LoadConfig();
        }

        private new void LoadConfig()
        {
            GetConfig(ref C.listw, "HandsSmelt", "SmeltTools(id pickaxe)");
            SaveConfig();
        }

        protected override void LoadDefaultConfig() => PrintWarning("Creating new config file for HandsSmelt...");

        bool perm(PlayerSession session) => permission.UserHasPermission(session.SteamId.ToString(), "handssmelt.use");

        void OnDispenserGather(GameObject resourceNode, HurtMonoBehavior player, List<ItemInstance> items)
        {
            if (resourceNode == null || player == null || items == null)
                return;

            string tmpName = Convert.ToString(GetNameOfObject(resourceNode));
            var KillerName = tmpName.Remove(tmpName.Length - 3);
            var session = getSession(KillerName);
            var inv = session.WorldPlayerEntity.GetComponent<PlayerInventory>();
            var itemManager = GlobalItemManager.Instance;

            if (permission.UserHasPermission(session.SteamId.ToString(), "handssmelt.use"))
                items = ad(items);

            foreach (int v in C.listw)
            {
                if (iditem(session) == v)
                    items = ad(items);
            }
        }

        List<ItemInstance> ad(List<ItemInstance> items)
        {
            var itemManager = GlobalItemManager.Instance;

            for (int l = 0; l < items.Count; l++)
            {
                if (items[l].Item == itemManager.GetItem(18))
                    items[l].Item = itemManager.GetItem(36);

                if (items[l].Item == itemManager.GetItem(131))
                    items[l].Item = itemManager.GetItem(134);

                if (items[l].Item == itemManager.GetItem(132))
                    items[l].Item = itemManager.GetItem(135);

                if (items[l].Item == itemManager.GetItem(133))
                    items[l].Item = itemManager.GetItem(136);
            }
            return items;
        }

        string GetNameOfObject(UnityEngine.GameObject obj)
        {
            var ManagerInstance = GameManager.Instance;
            return ManagerInstance.GetDescriptionKey(obj);
        }

        int iditem(PlayerSession session)
        {
            var ehs = session.WorldPlayerEntity.GetComponent<EquippedHandlerServer>();
            var item = ehs.GetEquippedItem();

            if (item == null)
                return 0;
            return item.Item.ItemId;
        }

        private void GetConfig<T>(ref T variable, params string[] path)
        {
            if (path.Length == 0)
                return;

            if (Config.Get(path) == null)
            {
                Config.Set(path.Concat(new object[] { variable }).ToArray());
                PrintWarning($"Added field to config: {string.Join("/", path)}");
            }

            variable = (T)Convert.ChangeType(Config.Get(path), typeof(T));
        }

        private PlayerSession getSession(string identifier)
        {
            var sessions = GameManager.Instance.GetSessions();
            PlayerSession session = null;

            foreach (var i in sessions)
            {
                if (i.Value.Name.ToLower().Contains(identifier.ToLower()) || identifier.Equals(i.Value.SteamId.ToString()))
                {
                    session = i.Value;
                    break;
                }
            }

            return session;
        }
    }
}
